/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20131115-64 [Nov 25 2013]
 * Copyright (c) 2000 - 2013 Intel Corporation
 * 
 * Disassembly of ssdt3.dat, Sat Dec 14 10:33:49 2013
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000019EF (6639)
 *     Revision         0x01
 *     Checksum         0xD6
 *     OEM ID           "HPQOEM"
 *     OEM Table ID     "NVIDIAGF"
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20110112 (537985298)
 */
DefinitionBlock ("ssdt3.aml", "SSDT", 1, "HPQOEM", "NVIDIAGF", 0x00000001)
{
    /*
     * iASL Warning: There were 5 external control methods found during
     * disassembly, but additional ACPI tables to resolve these externals
     * were not specified. This resulting disassembler output file may not
     * compile because the disassembler did not know how many arguments
     * to assign to these methods. To specify the tables needed to resolve
     * external control method references, use the one of the following
     * example iASL invocations:
     *     iasl -e <ssdt1.aml,ssdt2.aml...> -d <dsdt.aml>
     *     iasl -e <dsdt.aml,ssdt2.aml...> -d <ssdt1.aml>
     */
    External (_SB_.ODGW, MethodObj)    // Warning: Unresolved Method, guessing 4 arguments (may be incorrect, see warning above)
    External (_SB_.PCI0.PEGP.DGFX.GDCC, MethodObj)    // Warning: Unresolved Method, guessing 2 arguments (may be incorrect, see warning above)
    External (_SB_.PCI0.PEGP.DGFX.PDOS, MethodObj)    // Warning: Unresolved Method, guessing 2 arguments (may be incorrect, see warning above)
    External (_SB_.SSMI, MethodObj)    // Warning: Unresolved Method, guessing 5 arguments (may be incorrect, see warning above)
    External (VRMB, MethodObj)    // Warning: Unresolved Method, guessing 3 arguments (may be incorrect, see warning above)

    External (_SB_.BCL_, IntObj)
    External (_SB_.BCM_, IntObj)
    External (_SB_.BQC_, IntObj)
    External (_SB_.DCKD, IntObj)
    External (_SB_.HDDC, IntObj)
    External (_SB_.LID_._LID, IntObj)
    External (_SB_.PCI0, DeviceObj)
    External (_SB_.PCI0.LPCB.EC0_.GACS)
    External (_SB_.PCI0.LPCB.EC0_.GPID)
    External (_SB_.PCI0.PEGP.DGFX, DeviceObj)
    External (_SB_.PCI0.PEGP.DGFX.)
    External (_SB_.SBRC, IntObj)
    External (BCCT, IntObj)
    External (BCLV, IntObj)
    External (BRID, IntObj)
    External (BRLV, IntObj)
    External (DCAP)
    External (DEDP, IntObj)
    External (DID1)
    External (DODI, IntObj)
    External (DODS)
    External (GDCC)
    External (MDTL, IntObj)
    External (NDOD, IntObj)
    External (SRCP)
    External (VRMS)
    External (WCOS)
    External (WDGN)
    External (WDPE)
    External (WDSA)
    External (WDSS, IntObj)
    External (WDST, IntObj)

    Scope (\_SB.PCI0.PEGP.DGFX)
    {
        Name (_S3D, 0x03)  // _S3D: S3 Device State
        Name (_S4D, 0x03)  // _S4D: S4 Device State
        Name (INIM, 0x00)
        Name (DIDX, Package (0x09)
        {
            0x0110, 
            0x80000100, 
            0x80004210, 
            0x80006330, 
            0x80006320, 
            0x80006340, 
            0x80002330, 
            0x80002320, 
            0x80002340
        })
        Name (DIDC, 0x00)
        Method (DIDM, 0, Serialized)
        {
            If (LEqual (DIDC, 0x00))
            {
                If (LEqual (DID1, 0x00))
                {
                    Store (DEDP, Index (DODS, 0x00))
                }

                Store (SizeOf (DODS), Local1)
                Store (0x00, Local0)
                While (LLess (Local0, Local1))
                {
                    Store (DerefOf (Index (DODI, Local0)), Local2)
                    Store (DerefOf (Index (DODS, Local0)), Local3)
                    Store (Local3, Index (DIDX, Local2))
                    Increment (Local0)
                }

                Store (0x01, DIDC)
            }

            Return (DIDX)
        }

        Method (_DOD, 0, NotSerialized)  // _DOD: Display Output Devices
        {
            Return (NDOD)
        }

        Method (_INI, 0, NotSerialized)  // _INI: Initialize
        {
            Store (0x01, INIM)
        }

        Method (_REG, 2, NotSerialized)  // _REG: Region Availability
        {
            If (LEqual (INIM, 0x01))
            {
                Store (0x00, INIM)
            }
        }

        Event (\_SB.BEVT)
        Event (\_SB.F4EV)
        Scope (\_GPE)
        {
            Method (VHOV, 3, Serialized)
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                While (One)
                {
                    Store (Arg2, _T_0)
                    If (LEqual (_T_0, 0x01))
                    {
                        If (And (Arg0, 0x80))
                        {
                            Notify (\_SB.PCI0.PEGP.DGFX.LCD, Arg0)
                        }
                        Else
                        {
                            If (LEqual (And (WDPE, 0x44), 0x00))
                            {
                                \_SB.PCI0.PEGP.DGFX.SBRV ()
                            }
                        }
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x02))
                        {
                            \_SB.PCI0.PEGP.DGFX.GDCC (0x01, \_SB.PCI0.PEGP.DGFX.DKET ())
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x03))
                            {
                                \_SB.PCI0.PEGP.DGFX.GLEV ()
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x04))
                                {
                                    If (LEqual (And (WDPE, 0x03), 0x00))
                                    {
                                        \_SB.PCI0.PEGP.DGFX.GF4E ()
                                    }
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x05))
                                    {
                                        \_SB.PCI0.PEGP.DGFX.GPUP ()
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_0, 0x06))
                                        {
                                            If (And (DCAP, 0x01))
                                            {
                                                \_SB.PCI0.PEGP.DGFX.SNXS ()
                                            }
                                            Else
                                            {
                                                Notify (\_SB.PCI0.PEGP.DGFX, 0x80)
                                            }
                                        }
                                        Else
                                        {
                                            If (LEqual (_T_0, 0x07))
                                            {
                                                \_SB.PCI0.PEGP.DGFX.RFHS (Arg0)
                                            }
                                            Else
                                            {
                                                If (LEqual (_T_0, 0x08))
                                                {
                                                    \_SB.PCI0.PEGP.DGFX.VWAK (Arg0)
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }

                    Break
                }

                Return (0x00)
            }

            Method (VBRE, 1, Serialized)
            {
                Store (0x01, Local1)
                If (Local1)
                {
                    Store (\_GPE.VHOV (Arg0, 0x00, 0x01), Local1)
                }
            }

            Method (VFN4, 0, Serialized)
            {
                Signal (\_SB.F4EV)
                Store (0x01, Local1)
                If (Local1)
                {
                    Store (\_GPE.VHOV (0x00, 0x00, 0x04), Local1)
                }
            }

            Method (VDET, 0, Serialized)
            {
                Store (0x01, Local1)
                If (Local1)
                {
                    Store (\_GPE.VHOV (0x00, 0x00, 0x02), Local1)
                }
            }

            Name (LRSC, 0x01)
            Method (VLET, 0, Serialized)
            {
                Store (0x01, LRSC)
                Store (0x01, Local1)
                If (Local1)
                {
                    Store (\_GPE.VHOV (0x00, 0x00, 0x03), Local1)
                }

                Return (LRSC)
            }

            Method (VPUP, 2, Serialized)
            {
                Store (0x01, Local1)
                If (Local1)
                {
                    Store (\_GPE.VHOV (Arg0, Arg1, 0x05), Local1)
                }
            }
        }

        Scope (\_SB)
        {
            Method (VSDD, 1, Serialized)
            {
                If (And (DCAP, 0x04))
                {
                    Return (0xFFFF)
                }
                Else
                {
                    If (LEqual (And (WDPE, 0x03), 0x00))
                    {
                        Store (Arg0, WDGN)
                        Store (0x01, Local1)
                        If (Local1)
                        {
                            Store (\_GPE.VHOV (Arg0, 0x00, 0x06), Local1)
                        }
                    }

                    Return (0x00)
                }

                Return (Zero)
            }

            Method (VGDD, 1, Serialized)
            {
                If (LAnd (And (DCAP, 0x04), Arg0))
                {
                    Return (0xFFFF)
                }
                Else
                {
                    If (And (DCAP, 0x01))
                    {
                        If (LEqual (Arg0, 0x00))
                        {
                            Wait (\_SB.F4EV, 0x0500)
                        }

                        Store (0x01, Local1)
                        If (Local1)
                        {
                            Store (\_GPE.VHOV (Arg0, 0x00, 0x07), Local1)
                        }
                    }
                    Else
                    {
                        If (Arg0)
                        {
                            \_SB.SSMI (0xEA74, 0x02, 0x00, 0x00, 0x00)
                        }
                    }

                    Return (WDST)
                }
            }

            Method (VWAK, 1, Serialized)
            {
                Store (0x01, Local1)
                If (Local1)
                {
                    Store (\_GPE.VHOV (Arg0, 0x00, 0x08), Local1)
                }
            }

            Method (WBRT, 0, NotSerialized)
            {
                Store (0x01, Local1)
                If (Local1)
                {
                    Store (\_GPE.VHOV (0x00, 0x00, 0x09), Local1)
                }
            }
        }

        Method (_DOS, 1, NotSerialized)  // _DOS: Disable Output Switching
        {
            And (WDPE, 0xF8, Local0)
            And (WDPE, 0x83, Local1)
            Or (Local0, Arg0, WDPE)
            If (CondRefOf (^PDOS, Local2))
            {
                ^PDOS (Arg0, Local1)
            }
        }

        Device (LCD)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x00))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                If (\_SB.LID._LID)
                {
                    Return (DCS (0x00))
                }
                Else
                {
                    Return (0x00)
                }
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x00))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x00, Arg0)
            }

            Method (_BCL, 0, Serialized)  // _BCL: Brightness Control Levels
            {
                If (LLessEqual (\WCOS, 0x07))
                {
                    Return (\_SB.BCL)
                }
                Else
                {
                    Return (\_SB.BCL)
                }
            }

            Method (_BCM, 1, Serialized)  // _BCM: Brightness Control Method
            {
                Store (\_SB.BCM, Arg0)
                Local0
                If (Local0)
                {
                    Store (BRID, Local1)
                    If (LEqual (SBRV (), 0x00))
                    {
                        \_SB.SSMI (0xEA74, 0x04, Local1, 0x00, 0x00)
                    }

                    Signal (\_SB.BEVT)
                }
            }

            Method (_BQC, 0, Serialized)  // _BQC: Brightness Query Current
            {
                Return (\_SB.BQC)
            }
        }

        Device (CRT)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x01))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x01))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x01))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x01, Arg0)
            }
        }

        Device (TV)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x02))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x02))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x02))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x02, Arg0)
            }
        }

        Device (DVI)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x03))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x03))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x03))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x03, Arg0)
            }
        }

        Device (DD04)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x04))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x04))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x04))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x04, Arg0)
            }
        }

        Device (DD05)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x05))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x05))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x05))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x05, Arg0)
            }
        }

        Device (DD06)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x06))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x06))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x06))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x06, Arg0)
            }
        }

        Device (DD07)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x07))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x07))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x07))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x07, Arg0)
            }
        }

        Device (DD08)
        {
            Method (_ADR, 0, Serialized)  // _ADR: Address
            {
                Return (ADR (0x08))
            }

            Method (_DCS, 0, NotSerialized)  // _DCS: Display Current Status
            {
                Return (DCS (0x08))
            }

            Method (_DGS, 0, NotSerialized)  // _DGS: Display Graphics State
            {
                Return (DGS (0x08))
            }

            Method (_DSS, 1, NotSerialized)  // _DSS: Device Set State
            {
                DSS (0x08, Arg0)
            }
        }

        Method (ADR, 1, Serialized)
        {
            Store (DIDM (), Local1)
            Store (SizeOf (Local1), Local2)
            If (LLess (Arg0, Local2))
            {
                Store (DerefOf (Index (Local1, Arg0)), Local0)
                If (LLess (\WCOS, 0x06))
                {
                    And (Local0, 0xFFFF, Local0)
                }
            }
            Else
            {
                Store (0x00, Local0)
            }

            Return (Local0)
        }

        Method (DCS, 1, Serialized)
        {
            ShiftLeft (0x01, Arg0, Local1)
            Store (0x00, Local0)
            If (And (GDCC (0x00, Local1), Zero, Store (0x01, Local0)))
            {
                If (And (WDST, Local1))
                {
                    Store (0x1D, Local0)
                    If (And (WDSA, Local1))
                    {
                        Store (0x1F, Local0)
                    }
                }
            }

            Return (Local0)
        }

        Method (DGS, 1, Serialized)
        {
            ShiftLeft (0x01, Arg0, Local2)
            Store (0x00, Local0)
            If (And (WDGN, Local2))
            {
                Store (0x01, Local0)
            }

            Return (Local0)
        }

        Method (DSS, 2, Serialized)
        {
            ShiftLeft (0x01, Arg0, Local1)
            Store (WDSS, Local0)
            If (And (Arg1, 0x01))
            {
                Or (Local0, Local1, Local0)
            }
            Else
            {
                And (Local0, Not (Local1), Local0)
            }

            Store (Local0, WDSS)
            If (And (Arg1, 0x40000000))
            {
                Store (Local0, WDSA)
            }
        }

        Scope (\_SB.PCI0.PEGP.DGFX)
        {
            Name (MXM3, Buffer (0x81)
            {
                /* 0000 */   0x4D, 0x58, 0x4D, 0x5F, 0x03, 0x00, 0x79, 0x00,
                /* 0008 */   0x30, 0x11, 0xB8, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0010 */   0x60, 0x7C, 0xE8, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0018 */   0x00, 0x00, 0xD2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0020 */   0x60, 0x69, 0xD2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0028 */   0x60, 0x6A, 0xDA, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0030 */   0x60, 0x6B, 0xE2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0038 */   0x20, 0x69, 0xD2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0040 */   0x20, 0x6A, 0xDA, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0048 */   0x20, 0x6B, 0xE2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0050 */   0x01, 0xE8, 0x03, 0x00, 0x02, 0x4C, 0x04, 0x00,
                /* 0058 */   0x13, 0x00, 0xE8, 0x03, 0x03, 0x01, 0xF4, 0x01,
                /* 0060 */   0xE5, 0x0D, 0x01, 0x03, 0x01, 0x91, 0xA8, 0x07,
                /* 0068 */   0x06, 0x10, 0x00, 0x00, 0xDC, 0x05, 0x00, 0x00,
                /* 0070 */   0xE8, 0x03, 0x00, 0x00, 0x16, 0x14, 0x00, 0x00,
                /* 0078 */   0xDC, 0x05, 0x00, 0x00, 0xE8, 0x03, 0x00, 0x00,
                /* 0080 */   0x62
            })
            Name (MXMV, Buffer (0x81)
            {
                /* 0000 */   0x4D, 0x58, 0x4D, 0x5F, 0x03, 0x00, 0x79, 0x00,
                /* 0008 */   0x30, 0x11, 0xB8, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0010 */   0x60, 0x7C, 0xE8, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0018 */   0x00, 0x00, 0xD2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0020 */   0x60, 0x69, 0xD2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0028 */   0x60, 0x6A, 0xDA, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0030 */   0x60, 0x6B, 0xE2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0038 */   0x20, 0x69, 0xD2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0040 */   0x20, 0x6A, 0xDA, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0048 */   0x20, 0x6B, 0xE2, 0xFF, 0xF9, 0x3E, 0x00, 0x00,
                /* 0050 */   0x01, 0x58, 0x02, 0x00, 0x02, 0x4C, 0x04, 0x00,
                /* 0058 */   0x13, 0x00, 0x58, 0x02, 0x03, 0x01, 0x90, 0x01,
                /* 0060 */   0xE5, 0x0D, 0x01, 0x03, 0x01, 0x91, 0xA8, 0x07,
                /* 0068 */   0x06, 0x10, 0x00, 0x00, 0xDC, 0x05, 0x00, 0x00,
                /* 0070 */   0xE8, 0x03, 0x00, 0x00, 0x16, 0x14, 0x00, 0x00,
                /* 0078 */   0xDC, 0x05, 0x00, 0x00, 0xE8, 0x03, 0x00, 0x00,
                /* 0080 */   0xE8
            })
            OperationRegion (NVMX, PCI_Config, 0x00, 0x02)
            Field (NVMX, WordAcc, NoLock, Preserve)
            {
                DVID,   16
            }

            Method (MXID, 0, NotSerialized)
            {
                Store (MXM3, Local0)
                If (LOr (LOr (LEqual (DVID, 0x0DFA), LEqual (DVID, 0x0DDA)), LOr (
                    LEqual (DVID, 0x0FFC), LEqual (DVID, 0x0FFB))))
                {
                    Store (MXMV, Local0)
                }

                Return (Local0)
            }

            Method (MXMI, 1, NotSerialized)
            {
                If (LEqual (Arg0, 0x30))
                {
                    Return (Arg0)
                }

                If (LEqual (Arg0, 0x00))
                {
                    Return (0x30)
                }

                Return (0x00)
            }

            Method (MXMS, 1, NotSerialized)
            {
                If (LEqual (Arg0, 0x30))
                {
                    Return (MXID ())
                }

                Return (0x00)
            }

            Method (UCMP, 2, NotSerialized)
            {
                If (LNotEqual (0x10, SizeOf (Arg0)))
                {
                    Return (0x00)
                }

                If (LNotEqual (0x10, SizeOf (Arg1)))
                {
                    Return (0x00)
                }

                Store (0x00, Local0)
                While (LLess (Local0, 0x10))
                {
                    If (LNotEqual (DerefOf (Index (Arg0, Local0)), DerefOf (Index (
                        Arg1, Local0))))
                    {
                        Return (0x00)
                    }

                    Increment (Local0)
                }

                Return (0x01)
            }

            Method (MDSM, 4, Serialized)
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                Store ("-----DGPU _DSM --------", Debug)
                Store (Arg1, Debug)
                Store (Arg2, Debug)
                Store (Arg3, Debug)
                If (LNotEqual (Arg1, 0x0300))
                {
                    Return (0x80000002)
                }

                While (One)
                {
                    Store (Arg2, _T_0)
                    If (LEqual (_T_0, 0x00))
                    {
                        Return (Buffer (0x04)
                        {
                             0x01, 0x00, 0x01, 0x01
                        })
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x18))
                        {
                            Return (0x30)
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x10))
                            {
                                CreateWordField (Arg3, 0x02, SUBF)
                                If (LOr (LEqual (SUBF, 0x30), LEqual (SUBF, 0x00)))
                                {
                                    Return (MXID ())
                                }
                                Else
                                {
                                    If (LOr (LLess (SUBF, 0x80), LGreater (SUBF, 0x8F)))
                                    {
                                        Return (0x80000001)
                                    }
                                }
                            }
                        }
                    }

                    Break
                }

                Return (0x80000002)
            }

            Method (_ROM, 2, NotSerialized)  // _ROM: Read-Only Memory
            {
                If (LLess (Arg0, VRMS))
                {
                    Store (VRMB (Local0, Add (Local0, 0x04, Local0), OperationRegion (OROM, SystemMemory, Add (Local0, 
                        Arg0), 0x1000)), Field (OROM, AnyAcc, NoLock, Preserve)
                        {
                            R4KB,   32768
                        })
                    If (LEqual (Arg1, 0x1000))
                    {
                        Return (R4KB)
                    }
                    Else
                    {
                        Store (Buffer (Arg1) {}, Local0)
                        Mid (R4KB, 0x00, Arg1, Local0)
                        Return (Local0)
                    }
                }
                Else
                {
                    Store (Buffer (0x01)
                        {
                             0x00
                        }, Local0)
                    Return (Local0)
                }
            }
        }

        Scope (\_SB.PCI0)
        {
            Device (WMI1)
            {
                Name (_HID, EisaId ("PNP0C14"))  // _HID: Hardware ID
                Name (_UID, "MXM2")  // _UID: Unique ID
                Name (_WDG, Buffer (0xA0)
                {
                    /* 0000 */   0x3C, 0x5C, 0xCB, 0xF6, 0xAE, 0x9C, 0xBD, 0x4E,
                    /* 0008 */   0xB5, 0x77, 0x93, 0x1E, 0xA3, 0x2A, 0x2C, 0xC0,
                    /* 0010 */   0x4D, 0x58, 0x01, 0x02, 0x21, 0x12, 0x90, 0x05,
                    /* 0018 */   0x66, 0xD5, 0xD1, 0x11, 0xB2, 0xF0, 0x00, 0xA0,
                    /* 0020 */   0xC9, 0x06, 0x29, 0x10, 0x58, 0x4D, 0x01, 0x00,
                    /* 0028 */   0x40, 0x2F, 0x1A, 0x92, 0xC4, 0x0D, 0x2D, 0x40,
                    /* 0030 */   0xAC, 0x18, 0xB4, 0x84, 0x44, 0xEF, 0x9E, 0xD2,
                    /* 0038 */   0xD0, 0x00, 0x01, 0x08, 0x95, 0x30, 0x26, 0x93,
                    /* 0040 */   0x5F, 0xDA, 0xA0, 0x46, 0x8B, 0x1C, 0xDB, 0x2F,
                    /* 0048 */   0x1F, 0x7D, 0x66, 0xAF, 0xD1, 0x00, 0x01, 0x08,
                    /* 0050 */   0x06, 0x70, 0x90, 0xBE, 0x03, 0xD6, 0x14, 0x47,
                    /* 0058 */   0x9A, 0xE2, 0x9D, 0xBA, 0x89, 0x97, 0xA8, 0x05,
                    /* 0060 */   0xD2, 0x00, 0x01, 0x08, 0xE1, 0x55, 0xD3, 0x21,
                    /* 0068 */   0x8D, 0x49, 0x1F, 0x4C, 0xAE, 0x01, 0x05, 0xCE,
                    /* 0070 */   0xF8, 0xDD, 0x05, 0x3F, 0xD3, 0x00, 0x01, 0x08,
                    /* 0078 */   0xF1, 0xED, 0xBC, 0xED, 0xC9, 0xBB, 0x0E, 0x42,
                    /* 0080 */   0xA3, 0xC0, 0x32, 0x2B, 0x1D, 0x37, 0xC3, 0xAA,
                    /* 0088 */   0xD4, 0x00, 0x01, 0x08, 0xE1, 0x84, 0x7E, 0x37,
                    /* 0090 */   0xDE, 0x13, 0xFB, 0x41, 0xA0, 0x96, 0x0F, 0x08,
                    /* 0098 */   0x52, 0x8B, 0xA6, 0x89, 0xD5, 0x00, 0x01, 0x08
                })
                Method (WMMX, 3, NotSerialized)
                {
                    CreateDWordField (Arg2, 0x00, FUNC)
                    If (LGreaterEqual (SizeOf (Arg2), 0x04))
                    {
                        CreateDWordField (Arg2, 0x04, ARGA)
                    }

                    If (LGreaterEqual (SizeOf (Arg2), 0x08))
                    {
                        CreateDWordField (Arg2, 0x08, ARGB)
                    }

                    If (LEqual (FUNC, 0x4D53445F))
                    {
                        If (LGreaterEqual (SizeOf (Arg2), 0x18))
                        {
                            CreateField (Arg2, 0x20, 0x80, MUID)
                            CreateDWordField (Arg2, 0x14, REVI)
                            CreateDWordField (Arg2, 0x18, SFNC)
                            CreateDWordField (Arg2, 0x1C, ARGD)
                            Return (\_SB.PCI0.PEGP.DGFX._DSM (MUID, REVI, SFNC, ARGD))
                        }
                    }

                    If (LEqual (FUNC, 0x494D584D))
                    {
                        Return (\_SB.PCI0.PEGP.DGFX.MXMI (ARGA))
                    }

                    If (LEqual (FUNC, 0x534D584D))
                    {
                        Return (\_SB.PCI0.PEGP.DGFX.MXMS (ARGA))
                    }

                    If (LEqual (FUNC, 0x4C43425F))
                    {
                        Return (\_SB.PCI0.PEGP.DGFX.LCD._BCL ())
                    }

                    Return (0x00)
                }

                Name (WQXM, Buffer (0x0580)
                {
                    /* 0000 */   0x46, 0x4F, 0x4D, 0x42, 0x01, 0x00, 0x00, 0x00,
                    /* 0008 */   0x70, 0x05, 0x00, 0x00, 0xE4, 0x2C, 0x00, 0x00,
                    /* 0010 */   0x44, 0x53, 0x00, 0x01, 0x1A, 0x7D, 0xDA, 0x54,
                    /* 0018 */   0x18, 0xD2, 0x95, 0x00, 0x01, 0x06, 0x18, 0x42,
                    /* 0020 */   0x10, 0x17, 0x10, 0x8A, 0xE6, 0x80, 0x42, 0x04,
                    /* 0028 */   0x92, 0x43, 0xA4, 0x30, 0x30, 0x28, 0x0B, 0x20,
                    /* 0030 */   0x86, 0xA4, 0x04, 0x16, 0x01, 0x21, 0xAF, 0x02,
                    /* 0038 */   0x6C, 0x0A, 0x30, 0x09, 0xA2, 0xFE, 0xFD, 0x21,
                    /* 0040 */   0x4A, 0x82, 0x43, 0x09, 0x81, 0x90, 0x44, 0x01,
                    /* 0048 */   0xE6, 0x05, 0xE8, 0x16, 0x60, 0x58, 0x80, 0x6D,
                    /* 0050 */   0x01, 0xA6, 0x05, 0x38, 0x86, 0xA4, 0xD2, 0xC0,
                    /* 0058 */   0x29, 0x81, 0xA5, 0x40, 0x48, 0xA8, 0x00, 0xE5,
                    /* 0060 */   0x02, 0x7C, 0x0B, 0xD0, 0x8E, 0x28, 0xC9, 0x02,
                    /* 0068 */   0x2C, 0xC3, 0x88, 0xC0, 0xA3, 0x60, 0x68, 0x1C,
                    /* 0070 */   0x1A, 0x3B, 0x0C, 0xCB, 0x04, 0xD3, 0x20, 0x0E,
                    /* 0078 */   0xA3, 0x6C, 0x64, 0x11, 0x18, 0xB7, 0x53, 0x01,
                    /* 0080 */   0x72, 0x05, 0x08, 0x13, 0x20, 0x1E, 0x55, 0x18,
                    /* 0088 */   0xCD, 0x41, 0x11, 0xB8, 0xD0, 0x18, 0x19, 0x10,
                    /* 0090 */   0xF2, 0x28, 0xC0, 0xEA, 0x28, 0x34, 0xA9, 0x04,
                    /* 0098 */   0x76, 0x2F, 0x40, 0xA3, 0x00, 0x6D, 0x02, 0x1C,
                    /* 00A0 */   0x0A, 0x50, 0x28, 0xC0, 0x1A, 0x86, 0x9C, 0x41,
                    /* 00A8 */   0xC8, 0x16, 0xB6, 0x30, 0x1A, 0x14, 0x60, 0x11,
                    /* 00B0 */   0x45, 0x23, 0x38, 0x8B, 0x8A, 0xE7, 0x24, 0x94,
                    /* 00B8 */   0x80, 0xF6, 0x86, 0x20, 0x3C, 0x63, 0x36, 0x86,
                    /* 00C0 */   0x27, 0xC4, 0x20, 0x95, 0x61, 0x08, 0x22, 0x6E,
                    /* 00C8 */   0x84, 0x63, 0x69, 0x7F, 0x10, 0x44, 0xBE, 0x82,
                    /* 00D0 */   0x71, 0xB3, 0x48, 0xA3, 0x41, 0x8D, 0x35, 0xC1,
                    /* 00D8 */   0xB1, 0x7B, 0x34, 0x27, 0xDC, 0xB9, 0x00, 0xE9,
                    /* 00E0 */   0x73, 0x13, 0xC8, 0xD1, 0x9D, 0x46, 0x9D, 0x83,
                    /* 00E8 */   0x26, 0xC3, 0x63, 0x58, 0x09, 0xFE, 0x03, 0x7C,
                    /* 00F0 */   0x0A, 0xC0, 0xBB, 0x06, 0xD4, 0xF4, 0x0F, 0x9E,
                    /* 00F8 */   0x09, 0x82, 0x43, 0x0D, 0xD1, 0xA3, 0x0E, 0x77,
                    /* 0100 */   0x02, 0xE7, 0x75, 0x24, 0x0C, 0xE2, 0x88, 0x8E,
                    /* 0108 */   0x1B, 0x3B, 0xAB, 0x93, 0x39, 0xE8, 0x52, 0x05,
                    /* 0110 */   0x98, 0x3D, 0x00, 0x68, 0x70, 0x09, 0x4E, 0xFB,
                    /* 0118 */   0x4C, 0x42, 0xBF, 0x07, 0x9C, 0x4F, 0xCF, 0x63,
                    /* 0120 */   0x63, 0x83, 0x40, 0x8D, 0xCC, 0xFF, 0x7F, 0x68,
                    /* 0128 */   0x0F, 0xF2, 0xB4, 0x62, 0x86, 0x7C, 0x16, 0x38,
                    /* 0130 */   0x2C, 0x26, 0x16, 0x42, 0x9B, 0xD4, 0x78, 0x80,
                    /* 0138 */   0xC0, 0x01, 0xE0, 0xD1, 0x20, 0xC2, 0x9B, 0x81,
                    /* 0140 */   0xE7, 0x6B, 0x82, 0x41, 0x21, 0xE4, 0x64, 0x3C,
                    /* 0148 */   0x28, 0x31, 0xE7, 0x03, 0x32, 0x97, 0x10, 0x0F,
                    /* 0150 */   0x01, 0xC7, 0x10, 0x23, 0xE8, 0x19, 0x15, 0x8D,
                    /* 0158 */   0xAC, 0x89, 0xF8, 0x0C, 0xE0, 0x71, 0x5B, 0x16,
                    /* 0160 */   0x08, 0x25, 0x30, 0xB0, 0xCF, 0x0D, 0xEF, 0x10,
                    /* 0168 */   0x86, 0xC5, 0x8D, 0x26, 0xB0, 0xCF, 0x17, 0x16,
                    /* 0170 */   0x38, 0x28, 0x14, 0xAC, 0xEF, 0x0A, 0x31, 0x9F,
                    /* 0178 */   0x07, 0x8E, 0xF3, 0x80, 0x2D, 0x7C, 0xA2, 0x04,
                    /* 0180 */   0xF8, 0x90, 0x3C, 0x1A, 0x78, 0x83, 0x84, 0x6F,
                    /* 0188 */   0xFD, 0x08, 0x40, 0x80, 0x9F, 0x18, 0x4C, 0x60,
                    /* 0190 */   0x79, 0xC0, 0xE8, 0x51, 0xDA, 0xAF, 0x00, 0x84,
                    /* 0198 */   0xE0, 0x2F, 0x16, 0x4F, 0x01, 0xAF, 0x03, 0x11,
                    /* 01A0 */   0x8E, 0x05, 0xA6, 0xC8, 0xB1, 0xA1, 0xE1, 0xF9,
                    /* 01A8 */   0xC1, 0x21, 0x7A, 0xD4, 0x73, 0x09, 0x7F, 0x34,
                    /* 01B0 */   0x51, 0x4E, 0xE1, 0x70, 0x7C, 0xE4, 0x30, 0x42,
                    /* 01B8 */   0xF8, 0x27, 0x8D, 0x27, 0x0F, 0x6B, 0xBE, 0x03,
                    /* 01C0 */   0x68, 0x4A, 0x6F, 0x01, 0xEF, 0x0F, 0x1E, 0x01,
                    /* 01C8 */   0x46, 0x80, 0x84, 0xA3, 0x09, 0x26, 0xF2, 0xE9,
                    /* 01D0 */   0x04, 0x54, 0xFF, 0xFF, 0xD3, 0x09, 0x60, 0x6A,
                    /* 01D8 */   0xCA, 0x41, 0xDF, 0x4E, 0x9E, 0x22, 0x02, 0x45,
                    /* 01E0 */   0x09, 0xF2, 0x12, 0xF0, 0x56, 0x12, 0x24, 0xC2,
                    /* 01E8 */   0x7B, 0xC9, 0x93, 0xC9, 0xD3, 0x89, 0xC5, 0x9D,
                    /* 01F0 */   0x52, 0x84, 0x11, 0xE5, 0xE8, 0x03, 0x85, 0x79,
                    /* 01F8 */   0x31, 0x78, 0x3F, 0x31, 0x64, 0x90, 0xB0, 0x9E,
                    /* 0200 */   0x47, 0xAC, 0x38, 0x01, 0x83, 0x45, 0x79, 0x43,
                    /* 0208 */   0x79, 0x3A, 0x61, 0x21, 0x1F, 0x1A, 0xD2, 0x70,
                    /* 0210 */   0x3A, 0x01, 0x28, 0xF0, 0xFF, 0x3F, 0x9D, 0xC0,
                    /* 0218 */   0x8F, 0x7A, 0x3A, 0x41, 0x0F, 0xD7, 0xA7, 0x0C,
                    /* 0220 */   0x0C, 0xF2, 0x01, 0xF9, 0xD4, 0xE1, 0x73, 0xC0,
                    /* 0228 */   0x69, 0xF8, 0x78, 0x82, 0x11, 0x75, 0x3C, 0x41,
                    /* 0230 */   0x9D, 0x1E, 0x7C, 0x3C, 0x61, 0xE7, 0x83, 0xB3,
                    /* 0238 */   0x78, 0x0C, 0xF0, 0xE9, 0x04, 0x73, 0x4F, 0xF0,
                    /* 0240 */   0xE9, 0x04, 0x6C, 0xA3, 0x81, 0x71, 0x3C, 0x01,
                    /* 0248 */   0xDF, 0xD1, 0x05, 0x77, 0x3C, 0x01, 0xC3, 0x60,
                    /* 0250 */   0x60, 0x9C, 0x4F, 0x80, 0xC7, 0x78, 0x71, 0xC7,
                    /* 0258 */   0x00, 0x0F, 0x81, 0x0F, 0xE0, 0x71, 0xE3, 0xF4,
                    /* 0260 */   0xAC, 0x74, 0x52, 0xC8, 0x93, 0x08, 0x1F, 0x14,
                    /* 0268 */   0xE6, 0xC0, 0x02, 0x1C, 0xFE, 0xFF, 0x07, 0x16,
                    /* 0270 */   0xC0, 0xD4, 0xFD, 0xE0, 0x94, 0x9F, 0x57, 0x7C,
                    /* 0278 */   0x61, 0x31, 0xF2, 0x3B, 0xCA, 0x8B, 0x4A, 0x8C,
                    /* 0280 */   0x03, 0x7F, 0x57, 0x89, 0xE2, 0x11, 0xBC, 0xA9,
                    /* 0288 */   0x44, 0x0B, 0xF6, 0xC0, 0xE2, 0xE3, 0x8A, 0x8F,
                    /* 0290 */   0x68, 0xC6, 0x8B, 0x75, 0x18, 0xAF, 0x2E, 0x46,
                    /* 0298 */   0x8A, 0x12, 0x33, 0xDE, 0xCB, 0x9A, 0x21, 0x1E,
                    /* 02A0 */   0x58, 0x00, 0x36, 0xFC, 0xFF, 0x0F, 0x2C, 0xC0,
                    /* 02A8 */   0xE4, 0x1A, 0xF4, 0xC0, 0x02, 0x8C, 0x47, 0xC3,
                    /* 02B0 */   0x0E, 0x2C, 0xC0, 0x74, 0x30, 0xEC, 0xC0, 0x02,
                    /* 02B8 */   0xB8, 0xFC, 0xFF, 0x1F, 0x58, 0x00, 0x53, 0x07,
                    /* 02C0 */   0x52, 0xDF, 0x55, 0x62, 0x3C, 0x93, 0x32, 0x84,
                    /* 02C8 */   0x17, 0x95, 0xF7, 0x34, 0x1F, 0xD8, 0xF8, 0xD5,
                    /* 02D0 */   0xC0, 0x07, 0x83, 0xB7, 0x35, 0x83, 0x44, 0x7A,
                    /* 02D8 */   0x60, 0xF1, 0xD5, 0xC5, 0x10, 0x41, 0x23, 0xC6,
                    /* 02E0 */   0x88, 0xFA, 0xC0, 0xF2, 0xE0, 0x66, 0x9C, 0x18,
                    /* 02E8 */   0x0F, 0x2C, 0x00, 0x1B, 0xFE, 0xFF, 0x07, 0x16,
                    /* 02F0 */   0x60, 0x72, 0x15, 0x7A, 0x60, 0x01, 0xC6, 0xA3,
                    /* 02F8 */   0x61, 0x07, 0x16, 0x60, 0x3A, 0x18, 0x76, 0x60,
                    /* 0300 */   0x01, 0x5C, 0xFE, 0xFF, 0x0F, 0x6C, 0x80, 0xAB,
                    /* 0308 */   0x2B, 0xCA, 0x13, 0xAA, 0xEF, 0x29, 0x51, 0x5E,
                    /* 0310 */   0x51, 0x7C, 0x5B, 0x31, 0x88, 0x6F, 0x2B, 0x3E,
                    /* 0318 */   0xA8, 0xF9, 0x6C, 0xF0, 0xC0, 0x6A, 0x40, 0x76,
                    /* 0320 */   0x60, 0x35, 0xC4, 0x53, 0xAB, 0x11, 0x9E, 0x00,
                    /* 0328 */   0x82, 0x87, 0x3B, 0x91, 0x60, 0x11, 0x1E, 0x5D,
                    /* 0330 */   0x7C, 0x60, 0x01, 0xD8, 0xF0, 0xFF, 0x3F, 0xB0,
                    /* 0338 */   0x00, 0x93, 0x9B, 0xC0, 0x03, 0x0B, 0x30, 0x1E,
                    /* 0340 */   0x0D, 0x3B, 0xB0, 0x00, 0xD3, 0xC1, 0xB0, 0x03,
                    /* 0348 */   0x0B, 0xE0, 0xF2, 0xFF, 0x7F, 0x60, 0x01, 0x4C,
                    /* 0350 */   0x41, 0xBE, 0x13, 0xBC, 0xAB, 0x9C, 0x73, 0x8C,
                    /* 0358 */   0x57, 0x34, 0x43, 0xBF, 0xA8, 0xFA, 0x94, 0xEA,
                    /* 0360 */   0xDB, 0x8A, 0x81, 0x0C, 0x76, 0x4E, 0x0F, 0xAC,
                    /* 0368 */   0x46, 0x7A, 0x6A, 0x61, 0xB7, 0x55, 0x83, 0x3C,
                    /* 0370 */   0xB9, 0x18, 0xE1, 0xE8, 0x43, 0x1F, 0xC0, 0x8B,
                    /* 0378 */   0xAB, 0x0F, 0x2C, 0x00, 0x1F, 0xFE, 0xFF, 0x07,
                    /* 0380 */   0x16, 0xE0, 0x71, 0x2A, 0xF6, 0x81, 0x05, 0xF8,
                    /* 0388 */   0x8E, 0x86, 0x1F, 0x58, 0x80, 0xE7, 0x60, 0xF8,
                    /* 0390 */   0x81, 0x05, 0x70, 0xF9, 0xFF, 0x3F, 0xB0, 0x00,
                    /* 0398 */   0xAE, 0x0E, 0x08, 0xBE, 0x10, 0xC6, 0x08, 0xEC,
                    /* 03A0 */   0xDB, 0xAA, 0xD1, 0x8E, 0xFB, 0x81, 0x1D, 0x33,
                    /* 03A8 */   0x8E, 0xA7, 0x16, 0x5F, 0x56, 0x5E, 0x30, 0x1E,
                    /* 03B0 */   0x58, 0x0E, 0x3F, 0x9E, 0xAF, 0xEC, 0xC6, 0x7B,
                    /* 03B8 */   0x5A, 0xF5, 0xF1, 0x28, 0x4E, 0xC4, 0x08, 0x81,
                    /* 03C0 */   0x1F, 0x58, 0x01, 0x3E, 0xFC, 0xFF, 0x0F, 0x2C,
                    /* 03C8 */   0xC0, 0xE4, 0xC0, 0x0E, 0x8C, 0x47, 0xC3, 0x0F,
                    /* 03D0 */   0x2C, 0xC0, 0xF4, 0xC0, 0x0E, 0x18, 0xFD, 0xFF,
                    /* 03D8 */   0x1F, 0x58, 0x00, 0x53, 0x77, 0x74, 0x83, 0x86,
                    /* 03E0 */   0x7D, 0x46, 0x09, 0x11, 0xE1, 0x19, 0xE5, 0x45,
                    /* 03E8 */   0xC5, 0x18, 0x51, 0x9E, 0x55, 0x3D, 0x82, 0x58,
                    /* 03F0 */   0xCF, 0x05, 0xAF, 0x6C, 0x46, 0x3C, 0xF8, 0xA0,
                    /* 03F8 */   0x8F, 0x07, 0x51, 0x7C, 0x61, 0x31, 0xCE, 0x4B,
                    /* 0400 */   0x4B, 0x94, 0x08, 0x01, 0xA3, 0xF8, 0xDC, 0xEE,
                    /* 0408 */   0x03, 0x0B, 0xC0, 0x86, 0xFF, 0xFF, 0x81, 0x05,
                    /* 0410 */   0x98, 0x9C, 0x43, 0xD8, 0x81, 0x05, 0xD8, 0x8E,
                    /* 0418 */   0x86, 0x1D, 0x58, 0x80, 0xE9, 0x00, 0xD8, 0x81,
                    /* 0420 */   0x05, 0x70, 0xF9, 0xFF, 0x3F, 0xB0, 0x00, 0xA6,
                    /* 0428 */   0xEE, 0xAB, 0x86, 0x79, 0x42, 0x78, 0x44, 0xF7,
                    /* 0430 */   0x88, 0x1F, 0xD8, 0x19, 0xF8, 0x53, 0x4A, 0xA8,
                    /* 0438 */   0x28, 0x1E, 0x47, 0xA4, 0xF7, 0x80, 0x07, 0x56,
                    /* 0440 */   0xC3, 0x1D, 0x44, 0x3C, 0x9F, 0x55, 0x7C, 0x22,
                    /* 0448 */   0xF0, 0xE9, 0xDD, 0x90, 0xCF, 0x87, 0xBE, 0xB6,
                    /* 0450 */   0xFB, 0xC0, 0x06, 0xF0, 0xE1, 0xFF, 0x7F, 0x60,
                    /* 0458 */   0x01, 0x26, 0xE7, 0x80, 0x07, 0x16, 0x60, 0x3C,
                    /* 0460 */   0x1A, 0x76, 0x60, 0x01, 0xA6, 0x83, 0x61, 0x07,
                    /* 0468 */   0x16, 0xC0, 0xE5, 0xFF, 0xFF, 0xC0, 0x02, 0x98,
                    /* 0470 */   0xBA, 0x9F, 0xFB, 0x5E, 0xF1, 0x16, 0x60, 0x90,
                    /* 0478 */   0xB7, 0x54, 0x5F, 0xD4, 0x0D, 0x64, 0xF8, 0x07,
                    /* 0480 */   0x16, 0x5F, 0x0D, 0x3C, 0x8D, 0x07, 0x16, 0x9F,
                    /* 0488 */   0x0C, 0x42, 0xBD, 0xB2, 0xFA, 0xAE, 0x60, 0x84,
                    /* 0490 */   0x77, 0x56, 0x1F, 0x0F, 0x7C, 0x60, 0x8B, 0x15,
                    /* 0498 */   0x23, 0x5E, 0x84, 0x07, 0x16, 0x80, 0x0D, 0xFF,
                    /* 04A0 */   0xFF, 0x03, 0x0B, 0x30, 0xB9, 0x2C, 0xF8, 0xC0,
                    /* 04A8 */   0x02, 0x7C, 0x47, 0xC3, 0x0E, 0x2C, 0xC0, 0x74,
                    /* 04B0 */   0x30, 0xEC, 0xC0, 0x02, 0xB8, 0xFC, 0xFF, 0x1F,
                    /* 04B8 */   0x58, 0x00, 0x53, 0x27, 0x14, 0x23, 0x9C, 0xEF,
                    /* 04C0 */   0x3B, 0x5A, 0xE4, 0x07, 0x36, 0x06, 0x11, 0x2A,
                    /* 04C8 */   0x5E, 0x98, 0x07, 0x16, 0xDF, 0xD7, 0xAC, 0xF8,
                    /* 04D0 */   0xC0, 0x42, 0xE6, 0xE0, 0x7B, 0xAB, 0x41, 0xDE,
                    /* 04D8 */   0x5C, 0x42, 0xC4, 0x7D, 0x5B, 0x7B, 0x43, 0x78,
                    /* 04E0 */   0x6B, 0x37, 0x5A, 0xAC, 0x67, 0x56, 0x1F, 0x58,
                    /* 04E8 */   0x00, 0x36, 0xFC, 0xFF, 0x0F, 0x2C, 0xC0, 0xE4,
                    /* 04F0 */   0x28, 0xF0, 0xC0, 0x02, 0x8C, 0x47, 0xC3, 0x0E,
                    /* 04F8 */   0x2C, 0xC0, 0x74, 0x30, 0xEC, 0xC0, 0x02, 0x38,
                    /* 0500 */   0x51, 0x68, 0xD3, 0xA7, 0x46, 0xA3, 0x56, 0x0D,
                    /* 0508 */   0xCA, 0xD4, 0x28, 0xD3, 0xA0, 0x56, 0x9F, 0x4A,
                    /* 0510 */   0x8D, 0x19, 0x33, 0x04, 0xA5, 0x80, 0x0F, 0x01,
                    /* 0518 */   0x9D, 0x08, 0x2C, 0xEF, 0xD9, 0x20, 0x10, 0xCB,
                    /* 0520 */   0xA0, 0x10, 0x88, 0xA5, 0xBF, 0x5A, 0x04, 0xE2,
                    /* 0528 */   0xE0, 0x20, 0xFA, 0xFF, 0x83, 0x38, 0xE2, 0x93,
                    /* 0530 */   0x43, 0x60, 0xC4, 0x04, 0x18, 0x05, 0xA1, 0x11,
                    /* 0538 */   0x55, 0x80, 0x51, 0x1B, 0x60, 0x14, 0x84, 0x46,
                    /* 0540 */   0xD4, 0x01, 0x46, 0x8D, 0x80, 0x51, 0x10, 0x1A,
                    /* 0548 */   0x51, 0x09, 0x18, 0xB5, 0x02, 0x46, 0x41, 0x68,
                    /* 0550 */   0x44, 0x2D, 0x60, 0xD4, 0x0C, 0x18, 0x05, 0xA1,
                    /* 0558 */   0x11, 0xD5, 0x80, 0x51, 0x3B, 0x60, 0x14, 0x84,
                    /* 0560 */   0x46, 0xD4, 0x03, 0x46, 0x57, 0x28, 0x30, 0x02,
                    /* 0568 */   0x42, 0x23, 0x2A, 0x02, 0xA3, 0x96, 0xC0, 0x28,
                    /* 0570 */   0x08, 0x8D, 0xA8, 0x09, 0x8C, 0x9A, 0x02, 0xA3,
                    /* 0578 */   0x20, 0x34, 0xA2, 0x2A, 0x10, 0xF6, 0xFF, 0x07
                })
            }
        }

        Name (PSBR, 0x00)
        Name (BRIN, 0x00)
        Name (TGIX, 0x01)
        Name (MUID, Buffer (0x10)
        {
            /* 0000 */   0x00, 0xA4, 0x04, 0x40, 0x7D, 0x91, 0xF2, 0x4C,
            /* 0008 */   0xB8, 0x9C, 0x79, 0xB6, 0x2F, 0xD5, 0x56, 0x65
        })
        Name (NUID, Buffer (0x10)
        {
            /* 0000 */   0x75, 0x0B, 0xA5, 0xD4, 0xC7, 0x65, 0xF7, 0x46,
            /* 0008 */   0xBF, 0xB7, 0x41, 0x51, 0x4C, 0xEA, 0x02, 0x44
        })
        Name (BLHD, Package (0x0A)
        {
            0x00, 
            0x02, 
            0x00, 
            0x00, 
            0x04, 
            0x01, 
            0x05DC, 
            0x00, 
            0x03E8, 
            0x00
        })
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (LEqual (\SRCP, Arg0))
            {
                MUID
                0x01
                Return (MDSM (Arg0, Arg1, Arg2, Arg3))
            }

            If (LEqual (\SRCP, Arg0))
            {
                NUID
                0x01
                Return (NDSM (Arg0, Arg1, Arg2, Arg3))
            }

            Return (0x80000002)
        }

        Method (NDSM, 4, Serialized)
        {
            Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
            If (LNotEqual (Arg1, 0x0102))
            {
                Return (0x80000002)
            }

            Store (Buffer (0x04)
                {
                     0x00, 0x00, 0x00, 0x00
                }, Local0)
            CreateDWordField (Local0, 0x00, NVRD)
            While (One)
            {
                Store (Arg2, _T_0)
                If (LEqual (_T_0, 0x00))
                {
                    Store (0x00180063, NVRD)
                    If (LGreater (\WCOS, 0x05))
                    {
                        Or (WDPE, 0x40, WDPE)
                    }

                    Or (DCAP, 0x07, DCAP)
                    Return (Local0)
                }
                Else
                {
                    If (LEqual (_T_0, 0x01))
                    {
                        Store (0x0250, NVRD)
                        Return (Local0)
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x05))
                        {
                            CreateDWordField (Arg3, 0x00, ARGX)
                            CreateBitField (Arg3, 0x18, DMSK)
                            CreateField (Arg3, 0x19, 0x05, NCSN)
                            CreateBitField (Arg3, 0x1F, NCSM)
                            CreateField (Local0, 0x08, 0x06, TLSN)
                            If (NCSM)
                            {
                                Store (NCSN, TGIX)
                            }

                            If (DMSK)
                            {
                                And (ARGX, 0x03FF, Local1)
                                Store (TOHP (Local1), WDST)
                                ShiftRight (ARGX, 0x0C, Local1)
                                And (Local1, 0x03FF, Local1)
                                Store (TOHP (Local1), WDSA)
                                If (LEqual (WDSA, 0x01))
                                {
                                    Or (WDST, 0x01, WDGN)
                                    If (LEqual (WDGN, 0x01))
                                    {
                                        Store (0x01, TGIX)
                                    }
                                    Else
                                    {
                                        Store (0x02, TGIX)
                                    }
                                }
                                Else
                                {
                                    If (And (WDSA, 0x01))
                                    {
                                        If (LEqual (TGIX, 0x02))
                                        {
                                            Store (WDST, WDGN)
                                            Store (0x03, TGIX)
                                        }
                                        Else
                                        {
                                            And (WDST, Not (0x01), WDGN)
                                            Store (0x04, TGIX)
                                        }
                                    }
                                    Else
                                    {
                                        Store (0x01, WDGN)
                                        Store (0x01, TGIX)
                                    }
                                }

                                If (And (PSBR, 0x01))
                                {
                                    Signal (\_SB.F4EV)
                                    And (PSBR, Not (0x01), PSBR)
                                }
                            }

                            Store (TGIX, TLSN)
                            If (And (PSBR, 0x04))
                            {
                                And (PSBR, Not (0x04), PSBR)
                            }

                            If (\_SB.DCKD)
                            {
                                Or (NVRD, 0x20, NVRD)
                            }

                            If (And (PSBR, 0x02))
                            {
                                And (PSBR, Not (0x02), PSBR)
                            }

                            If (BRIN)
                            {
                                SBRV ()
                                Store (0x00, BRIN)
                            }

                            Return (Local0)
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x06))
                            {
                                If (LEqual (DerefOf (Index (MDTL, 0x00)), 0x00))
                                {
                                    Store (_DOD (), Local1)
                                    Store (SizeOf (Local1), Local0)
                                    Increment (Local0)
                                    Store (DerefOf (Index (Local1, 0x00)), Index (MDTL, 0x00))
                                    Store (0x2C, Index (MDTL, 0x01))
                                    Store (0x00, Local5)
                                    Store (0x02, Local2)
                                    Add (Local2, Local0, Local3)
                                    Add (Local3, Local0, Local4)
                                    While (LLess (Local5, Subtract (Local0, 0x01)))
                                    {
                                        Store (DerefOf (Index (Local1, Local5)), Local6)
                                        Store (Local6, Index (MDTL, Local2))
                                        Increment (Local2)
                                        Store (Local6, Index (MDTL, Local3))
                                        Increment (Local3)
                                        If (LGreater (Local5, 0x00))
                                        {
                                            Store (Local6, Index (MDTL, Local4))
                                            Increment (Local4)
                                        }

                                        Increment (Local5)
                                    }

                                    Store (0x26, Index (MDTL, Local2))
                                    Store (0x2B, Index (MDTL, Local3))
                                    Store (0x2B, Index (MDTL, Local4))
                                }

                                Return (MDTL)
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x13))
                                {
                                    \_SB.ODGW (0xC007, CreateDWordField (Arg3, 0x00, ARGY), \_SB.ODGW (ARGY, Store (0x04, 
                                        NVRD), \_SB.ODGW (0xC008, Return (NVRD), Else
                                                {
                                                    If (LEqual (_T_0, 0x14))
                                                    {
                                                        If (LEqual (\BCCT, 0x15))
                                                        {
                                                            Store (Package (0x34) {}, Local7)
                                                        }
                                                        Else
                                                        {
                                                            Store (Package (0x20) {}, Local7)
                                                        }

                                                        Store (0x00, Local0)
                                                        Subtract (SizeOf (BLHD), 0x01, Local2)
                                                        While (LLess (Local0, Local2))
                                                        {
                                                            Store (DerefOf (Index (BLHD, Local0)), Index (Local7, Local0))
                                                            Increment (Local0)
                                                        }

                                                        Store (\BCCT, Index (Local7, Local0))
                                                        Store (_DOD (), Local1)
                                                        Store (DerefOf (Index (Local1, 0x00)), Local2)
                                                        Store (Local2, Index (Local7, 0x00))
                                                        If (LLess (\WCOS, 0x06))
                                                        {
                                                            Store (0x0100, Index (Local7, 0x01))
                                                        }

                                                        If (LGreater (\WCOS, 0x06))
                                                        {
                                                            Store (0x0200, Index (Local7, 0x01))
                                                        }

                                                        Store (BRLV, Local5)
                                                        Store (BCLV, Local6)
                                                        Store (0x00, Local0)
                                                        While (LLess (Local0, \BCCT))
                                                        {
                                                            Add (Local0, SizeOf (BLHD), Local2)
                                                            Store (DerefOf (Index (Local5, Local0)), Local1)
                                                            Multiply (Local1, 0x03E8, Local3)
                                                            Divide (Add (Local3, 0x7F), 0xFF, Local4, Local1)
                                                            Store (Local1, Index (Local7, Local2))
                                                            Add (Local2, \BCCT, Local2)
                                                            Store (DerefOf (Index (Local6, Add (Local0, 0x02))), Local1)
                                                            Multiply (Local1, 0x0A, Index (Local7, Local2))
                                                            Increment (Local0)
                                                        }

                                                        Return (Local7)
                                                    }
                                                }, Break), Return (0x80000002)))
                                }
                            }
                        }
                    }
                }
            }
        }

        Method (DKET, 0, Serialized)
        {
            Or (PSBR, 0x04, PSBR)
            Notify (^, 0x81)
            Return (0x01)
        }

        Method (GF4E, 0, Serialized)
        {
            Or (PSBR, 0x01, PSBR)
            Notify (^, 0x80)
            Return (0x01)
        }

        Method (GLEV, 0, Serialized)
        {
            Or (PSBR, 0x02, PSBR)
            Notify (^, 0xDB)
        }

        Method (GPUP, 0, Serialized)
        {
            Store (0xD3, Local0)
            If (LEqual (\_SB.PCI0.LPCB.EC0.GACS, 0x01))
            {
                If (LEqual (\_SB.PCI0.LPCB.EC0.GPID, 0x00))
                {
                    Store (0xD1, Local0)
                }
                Else
                {
                    Store (0xD2, Local0)
                }
            }

            Notify (^, Local0)
            Return (0x01)
        }

        Method (SBRV, 0, Serialized)
        {
            Store (\_SB.SBRC, Local1)
            If (APBX (0x02))
            {
                If (PBIA ())
                {
                    Multiply (Local1, 0x03E8, Local2)
                    Divide (Local2, 0xFF, Local3, Local1)
                    ShiftLeft (Local1, 0x08, PBDI)
                    SPBC (0x86100000)
                }

                RPBX (0x02)
            }

            Return (0x01)
        }

        Method (RFHS, 1, Serialized)
        {
            Wait (\_SB.F4EV, 0x0500)
        }

        Method (SNXS, 0, Serialized)
        {
            Return (0x00)
        }

        Method (VWAK, 1, Serialized)
        {
            If (LGreaterEqual (Arg0, 0x03))
            {
                If (LEqual (And (WDPE, 0x44), 0x00))
                {
                    \_SB.ODGW (0xD5F2, Store (0x01, BRIN))
                }
            }
        }

        Method (TOHP, 1, Serialized)
        {
            Store (DODI, Local1)
            Store (SizeOf (Local1), Local3)
            Store (0x00, Local0)
            Store (Arg0, Local7)
            Store (0x00, Local2)
            While (LAnd (LLess (Local0, Local3), Local7))
            {
                ShiftLeft (0x01, Local0, Local4)
                If (And (Local7, Local4))
                {
                    Store (DerefOf (Index (Local1, Local0)), Local5)
                    ShiftLeft (0x01, Local5, Local6)
                    Or (Local2, Local6, Local2)
                }

                And (Local7, Not (Local4), Local7)
                Increment (Local0)
            }

            Return (Local2)
        }

        OperationRegion (GPPB, PCI_Config, 0xB4, 0x14)
        Field (GPPB, ByteAcc, NoLock, Preserve)
        {
            PBCI,   8, 
            PBNP,   8, 
            PBLS,   8, 
            PBCC,   8, 
            PBCR,   32, 
            PBDI,   32, 
            PBDO,   32, 
            PBMX,   32
        }

        Method (APBX, 1, Serialized)
        {
            Store (0x00, Local1)
            If (And (PBCC, 0x01))
            {
                Store (0x28, Local0)
                While (LGreater (Local0, 0x00))
                {
                    While (LAnd (LNotEqual (PBMX, 0x00), LGreater (Local0, 0x00)))
                    {
                        Sleep (0x32)
                        Decrement (Local0)
                    }

                    If (LEqual (PBMX, 0x00))
                    {
                        Store (Arg0, PBMX)
                        If (LEqual (PBMX, Arg0))
                        {
                            Store (0x01, Local1)
                            Break
                        }
                    }
                }
            }

            Return (Local1)
        }

        Method (RPBX, 1, Serialized)
        {
            Store (0x14, Local0)
            While (LAnd (LEqual (PBMX, Arg0), LGreater (Local0, 0x00)))
            {
                Store (0x00, PBMX)
                Decrement (Local0)
            }
        }

        Method (PBIA, 0, Serialized)
        {
            Store (0x0A, Local0)
            While (LAnd (And (PBCR, 0x02), LGreater (Local0, 0x00)))
            {
                Sleep (0x01)
                Decrement (Local0)
            }

            If (And (PBCR, 0x02))
            {
                Store (0x00, Local1)
            }
            Else
            {
                Store (0x01, Local1)
            }

            Return (Local1)
        }

        Method (SPBC, 1, Serialized)
        {
            Store (Arg0, PBCR)
        }

        Method (LCD._DDC, 1, Serialized)  // _DDC: Display Data Current
        {
            Return (\_SB.HDDC)
            Arg0
        }
    }
}

